<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProductCategoriesDiscoveryRequestStructure StructType
 * Meta informations extracted from the WSDL
 * - documentation: Requests for TYPE OF PRODUCT CATEGORY reference data for use in service requests.
 * @subpackage Structs
 */
class ProductCategoriesDiscoveryRequestStructure extends AbstractDiscoveryRequestStructure
{
    /**
     * The Language
     * @var string
     */
    public $Language;
    /**
     * The Extensions
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: Extensions
     * @var \StructType\ExtensionsStructure
     */
    public $Extensions;
    /**
     * The version
     * Meta informations extracted from the WSDL
     * - default: 2.0
     * - documentation: Version number of request. Fixed | A string indicating the versioin of a SIRI data structure.
     * @var string
     */
    public $version;
    /**
     * Constructor method for ProductCategoriesDiscoveryRequestStructure
     * @uses ProductCategoriesDiscoveryRequestStructure::setLanguage()
     * @uses ProductCategoriesDiscoveryRequestStructure::setExtensions()
     * @uses ProductCategoriesDiscoveryRequestStructure::setVersion()
     * @param string $language
     * @param \StructType\ExtensionsStructure $extensions
     * @param string $version
     */
    public function __construct($language = null, \StructType\ExtensionsStructure $extensions = null, $version = '2.0')
    {
        $this
            ->setLanguage($language)
            ->setExtensions($extensions)
            ->setVersion($version);
    }
    /**
     * Get Language value
     * @return string|null
     */
    public function getLanguage()
    {
        return $this->Language;
    }
    /**
     * Set Language value
     * @param string $language
     * @return \StructType\ProductCategoriesDiscoveryRequestStructure
     */
    public function setLanguage($language = null)
    {
        // validation for constraint: string
        if (!is_null($language) && !is_string($language)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($language)), __LINE__);
        }
        $this->Language = $language;
        return $this;
    }
    /**
     * Get Extensions value
     * @return \StructType\ExtensionsStructure|null
     */
    public function getExtensions()
    {
        return $this->Extensions;
    }
    /**
     * Set Extensions value
     * @param \StructType\ExtensionsStructure $extensions
     * @return \StructType\ProductCategoriesDiscoveryRequestStructure
     */
    public function setExtensions(\StructType\ExtensionsStructure $extensions = null)
    {
        $this->Extensions = $extensions;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\ProductCategoriesDiscoveryRequestStructure
     */
    public function setVersion($version = '2.0')
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ProductCategoriesDiscoveryRequestStructure
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
